

	
	
	
/////////////// BASE FUNCTIONS /////////////

	function makeUnselectable(node) {
		if (node.nodeType == 1) {
			node.setAttribute("unselectable", "on");
		}
		var child = node.firstChild;
		while (child) {
			makeUnselectable(child);
			child = child.nextSibling;
		}
		
		$('.inputNameInput').removeAttr('unselectable');
		$('body').removeAttr('unselectable');
		$('html').removeAttr('unselectable');
		$('ol').removeAttr('unselectable');
		$('input').removeAttr('unselectable');
		$('button').removeAttr('unselectable');
		$('label').removeAttr('unselectable');
		$('#confirmDelete').removeAttr('unselectable');
		$('#wrapper').removeAttr('unselectable');
	}
	
//-------------



	function getModelLayers(actionName) {
		query = 'skp:getModelLayers@' + actionName;
		window.location.href = query;
	}
	
//-------------


	function getActiveLayer() {
		window.location = 'skp:getActiveLayer@';
	}
	
//-------------


	function setActiveLayerFromRuby(layerName) {
		$(".enabled").removeClass("enabled").addClass("disabled");
		$("span").filter(function() { return ($(this).text() === layerName) }).closest("div").children(".active").removeClass("disabled").addClass("enabled");
	}
	
//-------------


	function setActiveLayerFromJS(layerName) {
		window.location = 'skp:setActiveLayerFromJS@' + layerName;
	}
	
//-------------
	
	
	function addLayerFromRuby(layerName, layerID) {
	
		if (layerID == 0) { var elem = "div" } //Make layer0 not sortable
		else { var elem = "li" }
		var layerStr = '<' + elem + ' id="id' + layerID + '" class="layer mjs-nestedSortable-no-nesting mjs-nestedSortable-leaf" unselectable="on"><div class="lidiv" unselectable="on"><div class="handle" unselectable="on"></div><div class="visibility visible" unselectable="on"></div><div class="active disabled" unselectable="on"></div><span class="inputName" ><input class="inputNameInput" type="text" value="' + layerName + '" /></span><span class="layerName"><span class="layerNameText" unselectable="on">' + layerName + '</span></span></div></li>'
		
		if($('.ui-selected').length > 0) {
			$('.ui-selected').last().parent().after(layerStr);
		}
		else {
			$('.sortable').append(layerStr);
		}
		
	}
	
	
//-------------
	
	
	function addLayerFromJS() {
	
		//Check if layer nb exists
		 var layerNb = 1;
		 while (true) {
			var layerName = 'Layer' + layerNb;
			if ($("span").filter(function() { return ($(this).text() === layerName) }).length) {
				layerNb++;
			} 
			else {
				break; // On quitte la boucle
			}
		}
		
		window.location = 'skp:addLayerFromJS@' + layerName;
	}
	
//-------------
	
	
	function addGroup() {
	
		//Check if Group nb exists
		var groupNb = 1;
		while (true) {
			var groupName = 'Group ' + groupNb;
			if ($("span").filter(function() { return ($(this).text() === groupName) }).length) {
				groupNb++;
			} 
			else {
				break; // On quitte la boucle
			}
		}
	
		$('.sortable').append('<li class="group mjs-nestedSortable-branch mjs-nestedSortable-expanded"><div class="lidiv"><div class="handle"></div><div class="visibility visible"></div><span class="disclose"></span><span class="inputName" ><input class="inputNameInput" type="text" /></span><span class="layerName"><span class="layerNameText">' + groupName + '</span></span></div><ol></ol></li>');
	}
	
//-------------
	
	
	function renameLayerFromJS(oldLayerName, newLayerName) {
	
		var layerNameS = { "oldLayerName":oldLayerName, "newLayerName":newLayerName }; //Json
		var JsonLayerNameS = $.toJSON( layerNameS );
		window.location = 'skp:renameLayerFromJS@' + JsonLayerNameS;
		
	}
	
	
//-------------
	
	
	function trash() {
	
		$('#id0').children('.lidiv').removeClass('ui-selected'); // Prevent Layer0 delete
		
		layerContent = false; //Reset
		
		$('.ui-selected').each(function() {
			if ($(this).parent().hasClass("group")) { // If Group
				$(this).parent().find('.lidiv').addClass('ui-selected'); // Select all nested layers and groups
			}
		});
		
		$('.ui-selected').each(function() {
			if ($(this).parent().hasClass("layer")) { // If layer
				if (layerContent == false) { // Continue while layerContent = false
					var layerName = $(this).children(".layerName").children(".layerNameText").text();
					window.location = 'skp:checkLayerForContent@' + layerName;
				}
			}
		});

		var deleteContent = false; // By default, don't delete contents
		if(layerContent == true){ // if layers have content, show popup
			$('#defaultDelete').attr('checked', true); // Check "move contents to default layer"
			$('#confirmDelete').show();
			$('#overlay').show();
			$(window).resize(); // Center delete popup
			
			$("#okDelete").click(function() {
				if ($('#deleteDelete').is(':checked')) { deleteContent = true; } // "delete contents" checked
				$('#confirmDelete').hide();
				$('#overlay').hide();
				trash2(deleteContent);
			});
			
			$("#cancelDelete").click(function() {
				$('#confirmDelete').hide();
				$('#overlay').hide();
			});
		}
		else {
			trash2(deleteContent);
		}
		
		deleteContent = false; // Reset

	}


	function trash2(deleteGeom) {
		$('.ui-selected').each(function() { // First, deal with layers
			if ($(this).parent().hasClass("layer")) { // If layer
				var layerName = $(this).children(".layerName").children(".layerNameText").text();
				deleteLayerFromJS(layerName, deleteGeom); 
			}
		});
		
		$('.ui-selected').each(function() { // Then, delete groups
			if ($(this).parent().hasClass("group")) { // If group
				$(this).parent().empty().remove();
			}
		});
	}
	
	
//-------------
	
	var layerContent = false
	function checkLayerForContent(layerName, layerHasContent) {
	
		if (layerHasContent == "true") { 
			layerContent = true;
		}
		
	}
	
	
//-------------
	
	
	function deleteLayerFromJS(layerName, deleteGeom) {
		if(deleteGeom == false) {
			window.location = 'skp:deleteLayerFromJS@' + layerName;
		}
		else {
			window.location = 'skp:deleteLayer&GeomFromJS@' + layerName;
		}
	}
	
	
//-------------
	
	
	function deleteLayerFromRuby(layerName) {
		$("span").filter(function() { return ($(this).text() === layerName) }).parent().parent().empty().remove();
	}
	
	
//-------------
	
	
	function showLayerFromJS(layerName) {
	
		window.location = 'skp:showLayerFromJS@' + layerName;
		
	}
	
	
//-------------
	
	
	function hideLayerFromJS(layerName, grouped) {
		
		window.location = 'skp:hideLayerFromJS@' + layerName;
		
	}
	
	
//-------------
	
	
	function showLayerFromRuby(layerName) {
	
		$("span").filter(function() { return ($(this).text() === layerName) }).closest("div").children(".visibility").removeClass("hidden").addClass("visible");
		
	}
	
	
//-------------
	
	
	function hideLayerFromRuby(layerName) {
	
		$("span").filter(function() { return ($(this).text() === layerName) }).closest("div").children(".visibility").removeClass("visible").addClass("hidden");
		
	}
	
	
//-------------
	
	
	
	
	
	
	////////////////////////
	
	
	


$(document).ready(function(){

	makeUnselectable(document);


	// $(document).bind("contextmenu", function(e) { // Disable right-click
		// return false;
	// });
	
	
	
	getModelLayers();
	getActiveLayer();

	
	

	$('ol.sortable')
		.nestedSortable({
			forcePlaceholderSize: true,
			handle: '.handle',
			helper:	'clone',
			items: 'li',
			opacity: .6,
			placeholder: 'placeholder',
			revert: 150,
			tabSize: 18,
			tolerance: 'pointer',
			toleranceElement: '> div',

			isTree: true,
			expandOnHover: 500
		})
		.selectable({cancel: ".visibility, .active, .handle, .disclose, .inputName, .layerNameText", filter: ".lidiv"});
		
	
	$(document).on('click', '.disclose', function (e) {
		if ($(this).closest('li').hasClass('mjs-nestedSortable-collapsed')) {
			$(this).closest('li').removeClass('mjs-nestedSortable-collapsed').addClass('mjs-nestedSortable-expanded');}
		else if ($(this).closest('li').hasClass('mjs-nestedSortable-expanded')) {
			$(this).closest('li').removeClass('mjs-nestedSortable-expanded').addClass('mjs-nestedSortable-collapsed');}
		else {
			$(this).closest('li').addClass('mjs-nestedSortable-collapsed');}
	});
	

	
	$(document).on('click', '.visibility', function (e) {
		
		var  goOn = true; 
		
		if ($(this).parent().parent().hasClass("group")) { // If this is group, item = group
			var group = $(this).parent().parent();
		}
		
		while ($(this).parents(".group").hasClass("hiddenGroup")) { // If nested in hidden group, click the hidden group
			goOn = false;
			if(group) {
				if(group[0] === $(this).parents(".hiddenGroup").last()[0]) {  // Go on if this group is highest hidden group
					goOn = true; 
					group.removeClass("hiddenGroup");
				}
				else { 
					$(this).parents(".hiddenGroup").last().removeClass("hiddenGroup").children(".lidiv").children(".visibility").click();
				}
			}
			else { 
				$(this).parents(".hiddenGroup").last().removeClass("hiddenGroup").children(".lidiv").children(".visibility").click();
			}
			
			if ($(this).hasClass("hidden")) { goOn = true; }
		}
		
	
		if (goOn) { // Not nested in hidden group
	
			if ($(this).parent().parent().hasClass("group")) { // If group
				if ($(this).is(".hidden, .hiddenByGroup")) { // Hidden
					$(this).addClass("visible").removeClass("hidden");
					$(this).parent().parent().children("ol").children(".layer").children(".lidiv").children(".hiddenByGroup").each(function(i) { // Show hiddenByGrouped layers
						layerName = $(this).parent().children(".layerName").children(".layerNameText").text();
						showLayerFromJS(layerName);
						$(this).removeClass("hiddenByGroup");
					});
					$(this).parent().parent().children("ol").find(".group").children(".lidiv").children(".hiddenByGroup").each(function(i) { // Show hiddenByGrouped groups
						$(this).click();
						$(this).removeClass("hiddenByGroup");
					});
					$(this).removeClass("hiddenGroup");
				}
				else { // visible
					if ($(this).parent().parent().children("ol").find(".layer").children(".lidiv").children(".active").hasClass("enabled")) { // If active layer is nested in this group
						alert('You cannot hide the current layer.');
					}
					else {
						$(this).addClass("hidden").removeClass("visible");
						$(this).parent().parent().addClass("hiddenGroup");
						$(this).parent().parent().children("ol").find(".layer").find(".visible:not(.hiddenByGroup)").each(function(i) { // HideGroup nested visible layers
							layerName = $(this).parent().children(".layerName").children(".layerNameText").text();
							hideLayerFromJS(layerName);
							$(this).addClass("hiddenByGroup");
						});
						$(this).parent().parent().children("ol").find(".group").find(".visible:not(.hiddenByGroup)").each(function(i) { // HideGroup nested visible groups
							$(this).addClass("hiddenByGroup");
						});
					}
				}
			}
			
			else { // If layer
			
				if ($(this).parent().children(".active").hasClass("enabled")) { // If active layer
					alert('You cannot hide the current layer.');
				}
				
				else {	// Not active layer
					layerName = $(this).parent().children(".layerName").children(".layerNameText").text();
					if ($(this).hasClass("visible")) {
						hideLayerFromJS(layerName);
					}
					else {
						showLayerFromJS(layerName);
					}
					$(this).toggleClass("hidden").toggleClass("visible");
				}
			}
		
		}
	});
	

		
	$( "ol.sortable" ).on( "sortstop", function( event, ui ) { // When an item is sorted
		if (ui.item.parent().parent().hasClass('group')) { // If parent is group
			if (ui.item.children(".lidiv").children(".visibility").hasClass("visible") && ui.item.parent().parent().children(".lidiv").children(".visibility").is(".hidden, .hiddenByGroup")) {  // If item is visible, and group is hidden or hiddenByGroup
				layerName = ui.item.find(".layerNameText").text();
				if (ui.item.hasClass("layer")) { hideLayerFromJS(layerName); } // If layer, hide it
				ui.item.children(".lidiv").children(".visibility").addClass("hiddenByGroup");
			}
		}
		else { // Item sorted outside group
			ui.item.children(".lidiv").children(".visibility").removeClass("hiddenByGroup");
			if (ui.item.hasClass("layer") && ui.item.children(".lidiv").children(".visibility").hasClass("visible")) { // If layer && visible
				layerName = ui.item.find(".layerNameText").text();
				showLayerFromJS(layerName);
			}
		}
	} );
	

	
	$(document).on('click', '.active', function (e) {
		layerName = $(this).parent().children(".layerName").children(".layerNameText").text();
		
		if ($(this).parent().children(".visibility").hasClass("hidden")) { // Layer hidden
			showLayerFromJS(layerName);
			$(this).parent().children(".visibility").toggleClass("hidden").toggleClass("visible");
		}
		
		$(".active").removeClass("enabled").addClass("disabled");
		$(this).toggleClass("enabled").toggleClass("disabled");
		setActiveLayerFromJS(layerName);
	});
	
	
	////////////// Layer0 /////////////////
	$('#id0 > .lidiv > .handle').addClass('handle0').removeClass('handle');
	
	
	
	
	////////////// RENAME /////////////////
	
	//Detect double click, hide name, show input
	$(document).on('dblclick', '.layerNameText', function (e) {
		if ($(this).closest('div').parent().is('#id0')) {} //Can't rename Layer0
		else {
			var name = $(this).text();
			$(this).closest('div').children(".layerName").hide();
			$(this).closest('div').children(".inputName").css('display', 'block').children(".inputNameInput").val(name).focus().select();
		}
	});
	
	//Detect enter key, trigger blur
	$(document).on('keyup', '.inputNameInput', function (e) {
		if ( e.keyCode === 13 ) { // 13 is enter key
			$(this).blur();
		}
	});
	
	//Detect esc key, fetch back the old name, trigger blur
	$(document).on('keyup', '.inputNameInput', function (e) {
		if ( e.keyCode === 27 ) { // 27 is enter key
			var name = $(this).closest('div').children(".layerName").children(".layerNameText").text();
			$(this).val(name);
			$(this).blur();
		}
	});
	
	//Detect blur, hide input and transfer name
	$(document).on('blur', '.inputNameInput', function (e) {
	
		var group = false;
		if ($(this).closest('div').parent().hasClass("mjs-nestedSortable-branch")) {
			var group = true;
		}
		
		var oldname = $(this).closest('div').children(".layerName").children(".layerNameText").text();
		var layerName = $(this).val();
		
		if( group == false && layerName.length == 0 ) { // Check if layer name is empty
			alert('Invalid Layer Name.\n\nLayer name must have at least one character.');
			$(this).focus();
		}
		
		else if ( oldname != layerName ) { // Name changes
			if ( group == false && $("span").filter(function() { return ($(this).text() === layerName) }).length) { // Check if layer name already exists
				alert('Invalid Layer Name.\n\nLayer name must be unique.');
				$(this).focus();
			}
			else {
				var layerName = $(this).val();
				$(this).closest('span').hide();
				$(this).closest('div').children(".layerName").show();
				$(this).closest('div').children(".layerName").children(".layerNameText").text(layerName);
				if (group == false) {
					renameLayerFromJS(oldname, layerName); // Send rename to ruby
				}
			}
		}
		
		else { // Name doesn't change
			$(this).closest('span').hide();
			$(this).closest('div').children(".layerName").show();
		}
	});
	
	
	
	
	////////////// FOOTER ////////////////
	
	$('.footerElement').hover(function () {
		$(this).toggleClass('footerHover');
	});
	
	
	// Add a new Layer
	$('.newLayer').click(addLayerFromJS);
	
	
	// Add a new group
	$('.newGroup').click(addGroup);
	
	
	// Delete group or layer
	$('.trash').click(trash);
	
	
	
	
	////////////// MENU ////////////////
	
	
	$('.menu').click(function () {
		$('#menu').show();
	});
	$(document).mouseup(function (e){ // Hide menu on click-outside
		var container = $("#menu");

		if (container.has(e.target).length === 0)
		{
			container.hide();
		}
	});
	
	$('#purgeLayers').click(function() {
		window.location = 'skp:purgeLayersFromJS';
		$('#menu').hide();
	});
	
	
	////////////// POPUP ////////////////
	
	//Center delete dialog on resize
	$(window).resize(function(){
		if($(window).width() > 340){ var width1 = 300 } 
		else { var width1 = $(window).width() - 40 }
		$('#wrapper').css({
			position:'absolute',
			left: ($(window).width() - $('#wrapper').outerWidth())/2,
			top: ($(window).height() - $('#wrapper').outerHeight())/2,
			width: width1
		});
	});
	// To initially run the function:
	$(window).resize();
	$(window).resize();

});
